<?php
/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'getMessagesRequest' => '\\StructType\\GetMessagesRequest',
            'userMessageLoadingResponse' => '\\StructType\\UserMessageLoadingResponse',
            'messages' => '\\StructType\\Messages',
            'baseResponse' => '\\StructType\\BaseResponse',
            'messageDto' => '\\StructType\\MessageDto',
            'errorType' => '\\StructType\\ErrorType',
            'postConversationRequest' => '\\StructType\\PostConversationRequest',
            'contextDto' => '\\StructType\\ContextDto',
            'productDto' => '\\StructType\\ProductDto',
            'saleDto' => '\\StructType\\SaleDto',
            'userConversationPostingResponse' => '\\StructType\\UserConversationPostingResponse',
            'putMessageRequest' => '\\StructType\\PutMessageRequest',
            'userMessageAddingResponse' => '\\StructType\\UserMessageAddingResponse',
            'markAsUnreadRequest' => '\\StructType\\MarkAsUnreadRequest',
            'userConversationMarkingReadResponse' => '\\StructType\\UserConversationMarkingReadResponse',
            'markAsReadRequest' => '\\StructType\\MarkAsReadRequest',
            'deleteConversationRequest' => '\\StructType\\DeleteConversationRequest',
            'userConversationDeletingResponse' => '\\StructType\\UserConversationDeletingResponse',
            'deleteConversationsRequest' => '\\StructType\\DeleteConversationsRequest',
            'userSubjectLoadingResponse' => '\\StructType\\UserSubjectLoadingResponse',
            'subjects' => '\\StructType\\Subjects',
            'subject' => '\\StructType\\Subject',
            'getConversationsCountRequest' => '\\StructType\\GetConversationsCountRequest',
            'userConversationCountResponse' => '\\StructType\\UserConversationCountResponse',
            'userConversationCountTypeList' => '\\StructType\\UserConversationCountTypeList',
            'userConversationCountType' => '\\StructType\\UserConversationCountType',
            'getConversationByIdRequest' => '\\StructType\\GetConversationByIdRequest',
            'userConversationLoadingResponse' => '\\StructType\\UserConversationLoadingResponse',
            'userConversationLoadingType' => '\\StructType\\UserConversationLoadingType',
            'participants' => '\\StructType\\Participants',
            'participantDto' => '\\StructType\\ParticipantDto',
            'getConversationsRequest' => '\\StructType\\GetConversationsRequest',
            'userConversationsLoadingResponse' => '\\StructType\\UserConversationsLoadingResponse',
            'conversations' => '\\StructType\\Conversations',
        );
    }
}
