<?php

namespace ServiceType;

use \WsdlToPhp\PackageBase\AbstractSoapClientBase;

/**
 * This class stands for Put ServiceType
 * @subpackage Services
 */
class Put extends AbstractSoapClientBase
{
    /**
     * Method to call the operation originally named putMessage
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param string $apiKey
     * @param string $sign
     * @param string $time
     * @param \StructType\PutMessageRequest $putMessageRequest
     * @return \StructType\UserMessageAddingResponse|bool
     */
    public function putMessage($apiKey, $sign, $time, \StructType\PutMessageRequest $putMessageRequest)
    {
        try {
            $this->setResult($this->getSoapClient()->putMessage($apiKey, $sign, $time, $putMessageRequest));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Returns the result
     * @see AbstractSoapClientBase::getResult()
     * @return \StructType\UserMessageAddingResponse
     */
    public function getResult()
    {
        return parent::getResult();
    }
}
