<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for markAsUnreadRequest StructType
 * @subpackage Structs
 */
class MarkAsUnreadRequest extends AbstractStructBase
{
    /**
     * The conversationIds
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * @var string[]
     */
    public $conversationIds;
    /**
     * The lang
     * @var string
     */
    public $lang;
    /**
     * Constructor method for markAsUnreadRequest
     * @uses MarkAsUnreadRequest::setConversationIds()
     * @uses MarkAsUnreadRequest::setLang()
     * @param string[] $conversationIds
     * @param string $lang
     */
    public function __construct(array $conversationIds = array(), $lang = null)
    {
        $this
            ->setConversationIds($conversationIds)
            ->setLang($lang);
    }
    /**
     * Get conversationIds value
     * @return string[]|null
     */
    public function getConversationIds()
    {
        return $this->conversationIds;
    }
    /**
     * This method is responsible for validating the values passed to the setConversationIds method
     * This method is willingly generated in order to preserve the one-line inline validation within the setConversationIds method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateConversationIdsForArrayConstraintsFromSetConversationIds(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $markAsUnreadRequestConversationIdsItem) {
            // validation for constraint: itemType
            if (!is_string($markAsUnreadRequestConversationIdsItem)) {
                $invalidValues[] = is_object($markAsUnreadRequestConversationIdsItem) ? get_class($markAsUnreadRequestConversationIdsItem) : sprintf('%s(%s)', gettype($markAsUnreadRequestConversationIdsItem), var_export($markAsUnreadRequestConversationIdsItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The conversationIds property can only contain items of type string, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set conversationIds value
     * @throws \InvalidArgumentException
     * @param string[] $conversationIds
     * @return \StructType\MarkAsUnreadRequest
     */
    public function setConversationIds(array $conversationIds = array())
    {
        // validation for constraint: array
        if ('' !== ($conversationIdsArrayErrorMessage = self::validateConversationIdsForArrayConstraintsFromSetConversationIds($conversationIds))) {
            throw new \InvalidArgumentException($conversationIdsArrayErrorMessage, __LINE__);
        }
        $this->conversationIds = $conversationIds;
        return $this;
    }
    /**
     * Add item to conversationIds value
     * @throws \InvalidArgumentException
     * @param string $item
     * @return \StructType\MarkAsUnreadRequest
     */
    public function addToConversationIds($item)
    {
        // validation for constraint: itemType
        if (!is_string($item)) {
            throw new \InvalidArgumentException(sprintf('The conversationIds property can only contain items of type string, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->conversationIds[] = $item;
        return $this;
    }
    /**
     * Get lang value
     * @return string|null
     */
    public function getLang()
    {
        return $this->lang;
    }
    /**
     * Set lang value
     * @param string $lang
     * @return \StructType\MarkAsUnreadRequest
     */
    public function setLang($lang = null)
    {
        // validation for constraint: string
        if (!is_null($lang) && !is_string($lang)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($lang, true), gettype($lang)), __LINE__);
        }
        $this->lang = $lang;
        return $this;
    }
}
